package imo;

import mine.KeyManager;
import mine.Mine;

import java.awt.*;
import java.awt.event.*;

public class GamePaint implements PaintListener {


    Jiki ore;
    Sister sister;
    Sword sword;
    Imo imo;
    Turu turu;
    Body screen;

    int Love;
    boolean clearFlag;

    MainWorks mw;
    KeyManager km;

    /*** Constructer ********************************************/

    public GamePaint( MainWorks mw ){
	this.mw = mw;
	screen= new Body( 0, 0, 300, 300, 0, 0 );
	km = new KeyManager();
    }

    /*** Reset ***************************************************/

    public void resetData( String name, int level ){
	Love = 0;
	clearFlag = false;
	ore = new Jiki( 120, 120, name, screen, Images.chara );
	sister = new Sister( 0, 0, Images.chara );
	imo = new Imo( 280, 280, level, screen, Images.chara );
	sword = new Sword( Images.chara );
	turu = new Turu( Images.chara );
	km.reset();
    }
		
    /*** Paint ********************************************/

    public void paint( Graphics g ){
	g.setFont(Mine.getFont(14));
	sword.display(g);
	ore.display(g);
	sister.display(g);
	imo.display(g);
	turu.display(g);
	ore.displayHP(g);
	imo.displayHP(g);
    }

    /*** Hit Judge ********************************************/

    private void hit(){
	if( Body.Hit( ore, sister ) ){
	    ore.moveS();
	    Love++;
	}
	if( Body.Hit( ore, imo ) ){
	    if( imo.isAlive() ){
		ore.damage( imo, 1 );
	    }
	    else{
		ore.moveS();
	    }
	}
	if( turu.isAlive() && Body.Hit( ore, turu ) ){
	    ore.damage( imo, 3 );
	}
	if( sword.isAlive() && Body.Hit( sword, sister ) ){
	    sister.damage();
	}
	if( sword.isAlive() && Body.Hit( sword, imo ) ){
	    imo.damage( ore, 1 );
	}
	sword.move( ore );
    }
		
    /*** End Judge ********************************************/

    private void endjudge(){
	if( ore.hp <= 0 ){
	    mw.gameEnd(1);
	    return;
	}
	if( sister.hp <= 0 ){
	    mw.gameEnd(4);
	    return;
	}
	if( Body.Hit( imo, sister ) ){
	    mw.gameEnd(3);
	    return;
	}
	if( turu.isAlive() && Body.Hit( turu, sister ) ){
	    mw.gameEnd(3);
	    return;
	}
	if( Love >= 200 ){
	    mw.gameEnd(2);
	    return;
	}
	if( imo.hp <= 0 ){
	    clearFlag = true;
	    if( ore.hp == ore.hpMax ){
		if( Love >= 10 ){
		    mw.gameEnd(5);
		    return;
		}
	    }else{
		mw.gameEnd(0);
		return;
	    }
	}
    }

    /*** Get EXP *************************************/

    public int getEXP(){
	if (clearFlag) return ore.hp;
	return 0;
    }

    /*** Key **********************************************/

    public void keyReleased( KeyEvent e ){
	km.keyReleased(e);
    }
    public void keyPressed( KeyEvent e ){
	km.keyPressed(e);
    }

    /*** MainLoop ***********************************/

    public void run(){
	mw.sleep(20);
	mw.repaint();
	if( km.isEscape() || km.isKey('x') ) mw.gameStart();
	endjudge();
	ore.move( km.isUp(), km.isDown(), km.isLeft(), km.isRight() );
	imo.move( ore );
	sister.move();
	if( km.isEnter() || km.isKey('z') ) ore.shot( sword );
	imo.shot( turu );
	sword.move( ore );
	turu.move( imo );
	hit();
    }
}
