package imo;

import java.awt.Graphics;
import java.awt.Image;

class Imo extends Body {

    int hp;
    int hpMax;
    int level;

    int ShotWait;
    static final int ShotWaitMax = 150;

    int TurnWait;

    boolean AnimeFlag = true;
    int AnimeWait;
    static final int AnimeWaitMax = 7;

    int Face;
    static final int F_UP = 1;
    static final int F_DOWN = 2;
    static final int F_LEFT = 3;
    static final int F_RIGHT = 4;

    int Status;
    int StatusWait;
    static final int SwordWaitMax = 60;
    static final int DamageWaitMax = 5;
    static final int S_MOVE = 0;
    static final int S_SHOT = 1;
    static final int S_DAMAGE = 2;
    static final int S_DEAD = 3;

    static final int V_WALK = 1;
    static final int V_DAMAGE = 6;

    boolean Life;
    Body screen;
    Image img;
    double oldx, oldy;

    Imo( double x, double y, int level, Body screen, Image img ){
	super( x, y, 32, 32, 0, 0.5 );
	this.level = level;
	oldx = x;  oldy = y;
	hpMax = 10 + level;
	hp = hpMax;
	ShotWait = 300;
	TurnWait = 0;
	AnimeWait = 0;
	Face = 0;
	Status = 0;
	StatusWait = 0;
	Life = true;
		
	this.screen = screen;
	this.img = img;
    }

    public void shot( Turu turu ){
	if( ShotWait > 0 ) return;
	if( Status != S_MOVE ) return;
	turu.make( this, SwordWaitMax );
	ShotWait = ShotWaitMax + RND(100);
	Status = S_SHOT;
	StatusWait = SwordWaitMax;
    }
	
    public void move( Jiki ore ){
	ShotWait--;
	if( Life && 0 >= StatusWait-- )  Status = S_MOVE;
	anime();
	if( Status != S_SHOT )  turn();

	oldx = x;  oldy = y;

	switch( Status ){
	case S_MOVE:
	    v = V_WALK;
	    moveK( Face==1, Face==2, Face==3, Face==4 );
	    moveC( screen );
	    break;
	case S_SHOT:
	    break;
	case S_DAMAGE:
	    if( Face==F_UP && ore.Faces==F_DOWN )		break;
	    if( Face==F_DOWN && ore.Faces==F_UP )		break;
	    if( Face==F_LEFT && ore.Faces==F_RIGHT )	break;
	    if( Face==F_RIGHT && ore.Faces==F_LEFT )	break;
	    v = V_DAMAGE;
	    super.move();
	    break;
	default:
	}
    }
	
    public void turn(){
	if( 0 <= TurnWait-- ) return;
	switch( RND(10) ){
	case 0:
	case 1:
	case 2:
	    Face = 1;
	    break;
	case 3:
	case 4:
	    Face = 2;
	    break;
	case 5:
	case 6:
	case 7:
	    Face = 3;
	    break;
	case 8:
	case 9:
	    Face = 4;
	    break;
	default:
	}
	TurnWait = 10 + RND(10);
    }

    public void moveS(){
	x = oldx;
	y = oldy;
    }		
		
    private void anime(){
	if( 0 >= AnimeWait-- ){
	    AnimeFlag = !AnimeFlag;
	    AnimeWait = AnimeWaitMax;
	}
    }

    public void damage( Body teki, int d ){
	if( Status == S_DAMAGE )	return;
	if( Status == S_SHOT )		return;
	Status = S_DAMAGE;
	StatusWait = DamageWaitMax;
	hp -= d;
	if( hp <= 0 ){
	    hp = 0;
	    Life = false;
	    Status = S_DEAD;
	}
	angle = getAngle( teki, this );
    }
    public boolean isAlive(){
	return Life;
    }		
    public void display( Graphics g ){
	int axs = (int)x;
	int ays = (int)y;
	int axf = axs + xs;
	int ayf = ays + ys;
	int bxs = 0;
	int bys = 32*3;
	switch( Face ){
	case F_UP:		bxs += 32*6;	break;
	case F_DOWN:	bxs += 32*0;	break;
	case F_LEFT:	bxs += 32*2;	break;
	case F_RIGHT:	bxs += 32*4;	break;
	default:
	}
	if( AnimeFlag ) bxs += 32;
	switch( Status ){
	case S_MOVE:	bys += 32*0;	break;
	case S_DAMAGE:	bys += 32*1;	break;
	case S_SHOT:	bys += 32*2;	break;
	default:
	}

	int bxf = bxs + xs;
	int byf = bys + ys;
	if( Life ){
	    g.drawImage( img, axs, ays, axf, ayf, bxs, bys, bxf, byf, null );
	}
	else{
	    g.drawImage( img, axs, ays, axf, ayf, 32*8, 32*4, 32*9, 32*5, null );
	}
    }
    public void displayHP( Graphics g ){
	int axs = 190;
	int ays = 0;
	int axf = axs + 104;
	int ayf = ays + 32;
	int bxs = 107;
	int bys = 228;
	int bxf = bxs + 104;
	int byf = bys + 32;
	g.drawImage( img, axs, ays, axf, ayf, bxs, bys, bxf, byf, null );
	axs = 194;
	ays = 21;
	axf = axs + hp*96/hpMax;
	ayf = ays + 8;
	bxs = 107 + 4;
	bys = 267;
	bxf = bxs + hp*96/hpMax;
	byf = bys + 8;
	g.drawImage( img, axs, ays, axf, ayf, bxs, bys, bxf, byf, null );

	g.drawString(Texts.imosukelv + level, 190, 16);
    }
	
}
		
