package mine;

import java.awt.Component;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;

public class MouseManager implements MouseListener, MouseMotionListener {

    private int mX, mY;
    private boolean M_LEFT, M_RIGHT;

    /*** Constructer ******************************/

    public MouseManager(){
	reset();
    }

    public MouseManager( Component c ){
	super();
	c.addMouseListener(this);
	c.addMouseMotionListener(this);
    }

    /*** Reset ******************************/

    public void reset(){
	mX = 0;
	mY = 0;
	M_LEFT = false;
	M_RIGHT = false;
    }

    /*** Get Data **********************************/

    public int getX(){
	return mX;
    }
    public int getY(){
	return mY;
    }
    public boolean isLeft(){
	return M_LEFT;
    }
    public boolean isRight(){
	return M_RIGHT;
    }

    /*** MouseEvent ************************************/

    public void mouseClicked( MouseEvent e ){}
    public void mouseEntered( MouseEvent e ){}
    public void mouseExited( MouseEvent e ){}


    /*** MouseMoved *********************************/

    public void mouseMoved( MouseEvent e ){
	mX = e.getX();
	mY = e.getY();
	mouseMoveds(e);
    }

    /*** MouseReleased ********************************/

    public void mouseReleased( MouseEvent e ){
	switch( e.getModifiers() ){
	case 16:
	    M_LEFT = false;
	    leftReleased(e);
	    break;
	case 4:
	    M_RIGHT = false;
	    rightReleased(e);
	    break;
	default:
	    if( M_LEFT ) leftReleased(e);
	    if( M_RIGHT ) rightReleased(e);
	    M_LEFT = false;
	    M_RIGHT = false;
	}
    }

    /*** MousePressed **********************************/

    public void mousePressed( MouseEvent e ){
	switch( e.getModifiers() ) {
	case 16:
	    M_LEFT = true;
	    leftPressed(e);
	    break;
	case 4:
	    M_RIGHT = true;
	    rightPressed(e);
	    break;
	default:
	    if( M_LEFT ) rightPressed(e);
	    if( M_RIGHT ) leftPressed(e);
	    M_LEFT = true;
	    M_RIGHT = true;
	}
    }

    /*** MouseDragged *****************************/

    public void mouseDragged( MouseEvent e ){
	mX = e.getX();
	mY = e.getY();
	switch( e.getModifiers() ) {
	case 16:
	    leftDragged(e);
	    break;
	case 4:
	    rightDragged(e);
	    break;
	default:
	}
	
    }

    public void mouseMoveds( MouseEvent e ){}
    public void leftDragged( MouseEvent e ){}
    public void rightDragged( MouseEvent e ){}
    public void leftPressed( MouseEvent e ){}
    public void rightPressed( MouseEvent e ){}
    public void leftReleased( MouseEvent e ){}
    public void rightReleased( MouseEvent e ){}
}
