package mine;

import java.awt.*;
import java.awt.event.*;

public class UnitCanvas extends JCanvas {

    private Image offi;
    private Graphics offg;

    protected int hjx, hjy;         // Display Position
    protected int dx, dy;           // Display Size

    protected UnitMap V;

    /*** Constructer *****************************************************/

    public UnitCanvas( int width, int height ){
	super( width, height );
    }

    /*** UnitMap Setup **************************************/

    protected void setUnitMap( UnitMap V ){
	this.V = V;
	Dimension d = V.getUnitSize();
	Dimension c = getSize();
	dx = c.width / d.width;
	dy = c.height / d.height;
	hjx = 0;
	hjy = 0;
    }
		

    /*** Get and Set Data ************************************************/

    public Point getHJ(){
	return new Point( hjx, hjy );
    }
    public void setHJ( int hjx, int hjy ){
	this.hjx = hjx;
	this.hjy = hjy;
    }
    public Dimension getMapSize(){
	return new Dimension( dx, dy );
    }

    /*** Paint *****************************************************/

    public void update( Graphics g ){
	paint(g);
    }
    public void paint( Graphics g ){
	if( offi == null ){
	    Dimension unit = V.getUnitSize();
	    Dimension map = V.getSize();
	    offi = createImage( map.width * unit.width, map.height * unit.height );
	    offg = offi.getGraphics();
	}
	Dimension map = V.getSize();
	Dimension unit = V.getUnitSize();
	V.E( 0, 0, map.width, map.height, true, offg );
	int axs = 0;
	int ays = 0;
	int axf = dx * unit.width;
	int ayf = dy * unit.height;
	int bxs = hjx * unit.width;
	int bys = hjy * unit.height;
	int bxf = bxs + dx * unit.width;
	int byf = bys + dy * unit.height;
	g.drawImage( offi, axs, ays, axf, ayf, bxs, bys, bxf, byf, null );
    }
}
